﻿Procedure Draw_3D_Clock(gid, colframe = 0, coldial= 0, colpointer = 0)
  
  If StartVectorDrawing(CanvasVectorOutput(gid))
    ScaleCoordinates(DesktopResolutionX(), DesktopResolutionY())   
    AddPathBox(0, 0, GadgetWidth(gid), GadgetWidth(gid))
    VectorSourceColor(RGBA(255, 255, 255, 255))
    VectorFont(FontID(0), GadgetHeight(gid)/40)
    FillPath()
    
    BeginVectorLayer(255)
    
    ; Dial
    VectorSourceCircularGradient(GadgetWidth(gid)/2, GadgetHeight(gid)/2, GadgetWidth(gid)/2.5, -GadgetWidth(gid)/4, -GadgetHeight(gid)/4)
    VectorSourceGradientColor(RGBA(255, 255, 255, 255), 0)
    VectorSourceGradientColor(RGBA(255, 255, 255, 255), 0.1)
    If coldial > 0 
      VectorSourceGradientColor(coldial, 1.0)
    Else
      VectorSourceGradientColor(RGBA(223, 159, 159, 50), 1.0)
    EndIf
    AddPathCircle(GadgetWidth(gid)/2,GadgetHeight(gid)/2,GadgetWidth(gid)/2.5)
    FillPath()
    ClosePath()
    Text$= "PureBasic Clock"
    VectorSourceColor(RGBA(153, 51, 51, 150))
    MovePathCursor(GadgetHeight(gid)/2 - VectorTextWidth(Text$)/2, GadgetHeight(gid)/2.5)
    DrawVectorText(Text$)
    
    ; Frame
    VectorSourceCircularGradient(GadgetWidth(gid)/2,GadgetHeight(gid)/2,GadgetWidth(gid)/2)
    VectorSourceGradientColor(RGBA(0, 0, 0, 250), 0.65)
    If colframe = 0 : colframe = RGBA(153, 51, 51, 255) : EndIf
    VectorSourceGradientColor(colframe, 0.8)
    VectorSourceGradientColor(RGBA(0, 0, 0, 250), 0.95)
    AddPathCircle(GadgetWidth(gid)/2,GadgetHeight(gid)/2,GadgetWidth(gid)/2.5)
    StrokePath(GadgetWidth(gid)/15,#PB_Path_RoundEnd )
    
    EndVectorLayer()
    
    BeginVectorLayer(180)
    
    VectorSourceColor(RGBA(0,0,0,255))
    loop_step.f = 0
    While loop_step < 360
      ResetCoordinates()
      MovePathCursor(GadgetWidth(gid)/2, GadgetWidth(gid)/2)
      RotateCoordinates(GadgetWidth(gid)/2, GadgetHeight(gid)/2, loop_step)
      If Mod(loop_step, 15) = 0
        MovePathCursor(GadgetWidth(gid)/2, GadgetWidth(gid)/4.5)
        AddPathLine(GadgetWidth(gid)/2, GadgetWidth(gid)/6)
        StrokePath(GadgetWidth(gid)/100,#PB_Path_RoundEnd)
        ;add numbers ???
      Else
        MovePathCursor(GadgetWidth(gid)/2, GadgetWidth(gid)/5)
        AddPathLine(GadgetWidth(gid)/2, GadgetWidth(gid)/6)
        StrokePath(GadgetWidth(gid)/400,#PB_Path_RoundEnd)
      EndIf
      loop_step = loop_step + 6
    Wend
    
    EndVectorLayer()
    
    BeginVectorLayer(250)
    
    hours_angle.f = 0
    minutes_angle.f = 0
    hours.f = Hour(Date())
    minutes.f = Minute(Date())
    seconds.f = Second(Date())
    
    If (hours >= 12)
      hours = hours - 12
    EndIf
    
    seconds_angle = seconds * 6 
    minutes_angle = minutes * 6  + (seconds_angle/60)
    hours_angle = hours * 30 + (minutes/60) * 30
    
    ; Minutes
    VectorSourceColor(RGBA(0,0,0,255))
    ResetCoordinates()
    RotateCoordinates(GadgetWidth(gid)/2, GadgetHeight(gid)/2,minutes_angle)
    MovePathCursor(GadgetWidth(gid)/2 + GadgetWidth(gid)/80, GadgetHeight(gid)/2)
    AddPathLine(GadgetWidth(gid)/2 + GadgetWidth(gid)/200, GadgetHeight(gid)/6)
    AddPathLine(GadgetWidth(gid)/2 - GadgetWidth(gid)/200, GadgetHeight(gid)/6)
    AddPathLine(GadgetWidth(gid)/2 - GadgetWidth(gid)/80, GadgetHeight(gid)/2)
    FillPath(#PB_Path_Winding)
    AddPathCircle(GadgetWidth(gid)/2, GadgetHeight(gid)/2, GadgetWidth(gid)/80)
    FillPath(#PB_Path_Winding)
    
    ; Hours
    VectorSourceColor(RGBA(0,0,0,255))
    ResetCoordinates()
    RotateCoordinates(GadgetWidth(gid)/2, GadgetHeight(gid)/2,hours_angle)
    MovePathCursor(GadgetWidth(gid)/2 + GadgetWidth(gid)/80, GadgetHeight(gid)/2)
    AddPathLine(GadgetWidth(gid)/2 + GadgetWidth(gid)/200, GadgetHeight(gid)/4.5)
    AddPathLine(GadgetWidth(gid)/2 - GadgetWidth(gid)/200, GadgetHeight(gid)/4.5)
    AddPathLine(GadgetWidth(gid)/2 - GadgetWidth(gid)/80, GadgetHeight(gid)/2)
    FillPath(#PB_Path_Winding)
    AddPathCircle(GadgetWidth(gid)/2, GadgetHeight(gid)/2, GadgetWidth(gid)/80)
    FillPath(#PB_Path_Winding)
    
    ; Seconds
    VectorSourceColor(RGBA(150,0,0,255))
    ResetCoordinates()
    RotateCoordinates(GadgetWidth(gid)/2, GadgetHeight(gid)/2,seconds_angle)
    MovePathCursor(GadgetWidth(gid)/2 + GadgetWidth(gid)/100, GadgetHeight(gid)/2)
    AddPathLine(GadgetWidth(gid)/2, GadgetHeight(gid)/6)
    AddPathLine(GadgetWidth(gid)/2 - GadgetWidth(gid)/100, GadgetHeight(gid)/2)
    FillPath()
    AddPathCircle(GadgetWidth(gid)/2, GadgetHeight(gid)/2, GadgetWidth(gid)/100)
    FillPath()
    
    EndVectorLayer()
    
    StopVectorDrawing()
  EndIf
  
EndProcedure
Procedure Draw_3D_Thermometer(gid, tempvalue.f, colframe = 0, coldial= 0, colpointer = 0)
  
  If StartVectorDrawing(CanvasVectorOutput(gid))
    ScaleCoordinates(DesktopResolutionX(), DesktopResolutionY())   
    AddPathBox(0, 0, GadgetWidth(gid), GadgetWidth(gid))
    VectorSourceColor(RGBA(255, 255, 255, 255))
    VectorFont(FontID(0), GadgetHeight(gid)/40)
    FillPath()
    
    BeginVectorLayer(255)
    
    ; Dial
    VectorSourceCircularGradient(GadgetWidth(gid)/2, GadgetHeight(gid)/2, GadgetWidth(gid)/2.5, -GadgetWidth(gid)/4, -GadgetHeight(gid)/4)
    VectorSourceGradientColor(RGBA(255, 255, 255, 255), 0)
    VectorSourceGradientColor(RGBA(255, 255, 255, 255), 0.1)
    If coldial > 0 
      VectorSourceGradientColor(coldial, 1.0)
    Else
      VectorSourceGradientColor(RGBA(223, 159, 159, 50), 1.0)
    EndIf
    AddPathCircle(GadgetWidth(gid)/2,GadgetHeight(gid)/2,GadgetWidth(gid)/2.5)
    FillPath()
    Text$= "PureBasic Thermometer"
    VectorSourceColor(RGBA(153, 51, 51, 150))
    MovePathCursor(GadgetHeight(gid)/2 - VectorTextWidth(Text$)/2, GadgetHeight(gid)/2.5)
    DrawVectorText(Text$)
    
    
    ; Frame
    VectorSourceCircularGradient(GadgetWidth(gid)/2,GadgetHeight(gid)/2,GadgetWidth(gid)/2)
    VectorSourceGradientColor(RGBA(0, 0, 0, 250), 0.65)
    If colframe = 0 : colframe = RGBA(153, 51, 51, 255) : EndIf
    VectorSourceGradientColor(colframe, 0.8)
    VectorSourceGradientColor(RGBA(0, 0, 0, 250), 0.95)
    AddPathCircle(GadgetWidth(gid)/2,GadgetHeight(gid)/2,GadgetWidth(gid)/2.5)
    StrokePath(GadgetWidth(gid)/15,#PB_Path_RoundEnd )
    
    EndVectorLayer()
    
    BeginVectorLayer(180)
    
    VectorSourceColor(RGBA(0,0,0,255))
    loop_step.f = 0
    start_angle = -160
    end_angle = 160
    big_step.f = 40
    x.f = 0
    y.f = 0 
    min.f = -30
    max.f = 50
    angle.f = 0
    start_draw = start_angle
    
    VectorFont(FontID(0), GadgetHeight(gid)/25)
    
    While start_draw <= end_angle
      ResetCoordinates()
      MovePathCursor(GadgetWidth(gid)/2, GadgetWidth(gid)/2)
      RotateCoordinates(GadgetWidth(gid)/2, GadgetHeight(gid)/2, start_draw)
      If Mod(start_draw, big_step) = 0
        MovePathCursor(GadgetWidth(gid)/2, GadgetWidth(gid)/4.5)
        AddPathLine(GadgetWidth(gid)/2, GadgetWidth(gid)/6)
        StrokePath(GadgetWidth(gid)/100,#PB_Path_RoundEnd)
        outval = loop_step + min 
        out$ =  Str(outval)
        x = GadgetWidth(gid)/2 - VectorTextWidth(out$)/2
        y = GadgetWidth(gid)/4.4
        MovePathCursor(x, y)
        DrawVectorText(out$)
      Else
        MovePathCursor(GadgetWidth(gid)/2, GadgetWidth(gid)/5)
        AddPathLine(GadgetWidth(gid)/2, GadgetWidth(gid)/6)
        StrokePath(GadgetWidth(gid)/400,#PB_Path_RoundEnd)
      EndIf
      loop_step = loop_step + 1
      start_draw = start_draw+ (big_step/10)
    Wend
    
    ResetCoordinates()
    VectorFont(FontID(0), GadgetHeight(gid)/12)
    out$ = StrF(tempvalue,1) + "°C"
    VectorFont(FontID(0), GadgetHeight(gid)/12)
    MovePathCursor(GadgetWidth(gid)/2 - VectorTextWidth(out$)/2, GadgetWidth(gid)/1.8)
    DrawVectorText(out$)
    
    EndVectorLayer()
    
    BeginVectorLayer(250)
    
    ; Pointer
    If colpointer = 0 : colpointer = RGBA(0,0,0,255) : EndIf
    VectorSourceColor(colpointer)
    ResetCoordinates()
    angle = tempvalue + Abs(min)
    angle = (angle / (max-min)) * (Abs(start_angle) + end_angle)
    RotateCoordinates(GadgetWidth(gid)/2, GadgetHeight(gid)/2,angle + start_angle)
    MovePathCursor(GadgetWidth(gid)/2 + GadgetWidth(gid)/80, GadgetHeight(gid)/2)
    AddPathLine(GadgetWidth(gid)/2, GadgetHeight(gid)/6)
    AddPathLine(GadgetWidth(gid)/2 - GadgetWidth(gid)/80, GadgetHeight(gid)/2)
    FillPath()
    AddPathCircle(GadgetWidth(gid)/2, GadgetHeight(gid)/2, GadgetWidth(gid)/80)
    FillPath()
    
    EndVectorLayer()
    
    StopVectorDrawing()
  EndIf
  
EndProcedure
Procedure Draw_3D_Hygrometer(gid, humvalue.f, colframe = 0, coldial= 0, colpointer = 0)
  
  If StartVectorDrawing(CanvasVectorOutput(gid))
    ScaleCoordinates(DesktopResolutionX(), DesktopResolutionY())  
    AddPathBox(0, 0, GadgetWidth(gid), GadgetWidth(gid))
    VectorSourceColor(RGBA(255, 255, 255, 255))
    VectorFont(FontID(0), GadgetHeight(gid)/40)
    FillPath()
    
    BeginVectorLayer(255)
    
    ; Dial
    VectorSourceCircularGradient(GadgetWidth(gid)/2, GadgetHeight(gid)/2, GadgetWidth(gid)/2.5, -GadgetWidth(gid)/4, -GadgetHeight(gid)/4)
    VectorSourceGradientColor(RGBA(255, 255, 255, 255), 0)
    VectorSourceGradientColor(RGBA(255, 255, 255, 255), 0.1)
    If coldial > 0 
      VectorSourceGradientColor(coldial, 1.0)
    Else
      VectorSourceGradientColor(RGBA(223, 159, 159, 50), 1.0)
    EndIf
    AddPathCircle(GadgetWidth(gid)/2,GadgetHeight(gid)/2,GadgetWidth(gid)/2.5)
    FillPath()
    ClosePath()
    Text$= "PureBasic Hygrometer"
    VectorSourceColor(RGBA(153, 51, 51, 150))
    MovePathCursor(GadgetHeight(gid)/2 - VectorTextWidth(Text$)/2, GadgetHeight(gid)/2.5)
    DrawVectorText(Text$)
    
    ; Frame
    VectorSourceCircularGradient(GadgetWidth(gid)/2,GadgetHeight(gid)/2,GadgetWidth(gid)/2)
    VectorSourceGradientColor(RGBA(0, 0, 0, 250), 0.65)
    If colframe = 0 : colframe = RGBA(153, 51, 51, 255) : EndIf
    VectorSourceGradientColor(colframe, 0.8)
    VectorSourceGradientColor(RGBA(0, 0, 0, 250), 0.95)
    AddPathCircle(GadgetWidth(gid)/2,GadgetHeight(gid)/2,GadgetWidth(gid)/2.5)
    StrokePath(GadgetWidth(gid)/15,#PB_Path_RoundEnd )
    
    EndVectorLayer()
    
    BeginVectorLayer(180)
    
    VectorSourceColor(RGBA(0,0,0,255))
    loop_step.f = 0
    start_angle = -160
    end_angle = 160
    big_step.f = 32
    x.f = 0
    y.f = 0 
    min.f = 0
    max.f = 100
    angle.f = 0
    start_draw.f = start_angle
    
    VectorFont(FontID(0), GadgetHeight(gid)/25)
    
    While start_draw <= end_angle
      ResetCoordinates()
      MovePathCursor(GadgetWidth(gid)/2, GadgetWidth(gid)/2)
      RotateCoordinates(GadgetWidth(gid)/2, GadgetHeight(gid)/2, start_draw)
      If Mod(start_draw, big_step) = 0
        MovePathCursor(GadgetWidth(gid)/2, GadgetWidth(gid)/4.5)
        AddPathLine(GadgetWidth(gid)/2, GadgetWidth(gid)/6)
        StrokePath(GadgetWidth(gid)/100,#PB_Path_RoundEnd)
        outval = ((loop_step + min)/(end_angle - start_angle)) * (max-min)
        out$ =  Str(outval)
        x = GadgetWidth(gid)/2 - VectorTextWidth(out$)/2
        y = GadgetWidth(gid)/4.4
        MovePathCursor(x, y)
        DrawVectorText(out$)
      ElseIf Mod(start_draw, 4) = 0
        MovePathCursor(GadgetWidth(gid)/2, GadgetWidth(gid)/5)
        AddPathLine(GadgetWidth(gid)/2, GadgetWidth(gid)/6)
        StrokePath(GadgetWidth(gid)/400,#PB_Path_RoundEnd)
      EndIf
      loop_step = loop_step + 1
      start_draw = start_draw + 1
    Wend
    
    ResetCoordinates()
    VectorFont(FontID(0), GadgetHeight(gid)/12)
    out$ = StrF(humvalue,1) + "%"
    MovePathCursor(GadgetWidth(gid)/2 - VectorTextWidth(out$)/2, GadgetWidth(gid)/1.8)
    DrawVectorText(out$)
    
    EndVectorLayer()
    
    BeginVectorLayer(250)
    
    ; Pointer
    If colpointer = 0 : colpointer = RGBA(0,0,0,255) : EndIf
    VectorSourceColor(colpointer)
    ResetCoordinates()
    angle = humvalue + Abs(min)
    angle = (angle / (max-min)) * (Abs(start_angle) + end_angle)
    RotateCoordinates(GadgetWidth(gid)/2, GadgetHeight(gid)/2,angle + start_angle)
    MovePathCursor(GadgetWidth(gid)/2 + GadgetWidth(gid)/80, GadgetHeight(gid)/2)
    AddPathLine(GadgetWidth(gid)/2, GadgetHeight(gid)/6)
    AddPathLine(GadgetWidth(gid)/2 - GadgetWidth(gid)/80, GadgetHeight(gid)/2)
    FillPath()
    AddPathCircle(GadgetWidth(gid)/2, GadgetHeight(gid)/2, GadgetWidth(gid)/80)
    FillPath()
    
    EndVectorLayer()
    
    StopVectorDrawing()
  EndIf
  
EndProcedure
Procedure Draw_3D_Barometer(gid, pressvalue.f, colframe = 0, coldial= 0, colpointer = 0)
  
  If StartVectorDrawing(CanvasVectorOutput(gid))
    ScaleCoordinates(DesktopResolutionX(), DesktopResolutionY())
    AddPathBox(0, 0, GadgetWidth(gid), GadgetWidth(gid))
    VectorSourceColor(RGBA(255, 255, 255, 255))
    VectorFont(FontID(0), GadgetHeight(gid)/40)
    FillPath()
    
    BeginVectorLayer(255)
    
    ; Dial
    VectorSourceCircularGradient(GadgetWidth(gid)/2, GadgetHeight(gid)/2, GadgetWidth(gid)/2.5, -GadgetWidth(gid)/4, -GadgetHeight(gid)/4)
    VectorSourceGradientColor(RGBA(255, 255, 255, 255), 0)
    VectorSourceGradientColor(RGBA(255, 255, 255, 255), 0.1)
    If coldial > 0 
      VectorSourceGradientColor(coldial, 1.0)
    Else
      VectorSourceGradientColor(RGBA(223, 159, 159, 50), 1.0)
    EndIf
    AddPathCircle(GadgetWidth(gid)/2,GadgetHeight(gid)/2,GadgetWidth(gid)/2.5)
    FillPath()
    ClosePath()
    Text$= "PureBasic Barometer"
    VectorSourceColor(RGBA(153, 51, 51, 150))
    MovePathCursor(GadgetHeight(gid)/2 - VectorTextWidth(Text$)/2, GadgetHeight(gid)/2.5)
    DrawVectorText(Text$)
    
    ; Frame
    VectorSourceCircularGradient(GadgetWidth(gid)/2,GadgetHeight(gid)/2,GadgetWidth(gid)/2)
    VectorSourceGradientColor(RGBA(0, 0, 0, 250), 0.65)
    If colframe = 0 : colframe = RGBA(153, 51, 51, 255) : EndIf
    VectorSourceGradientColor(colframe, 0.8)
    VectorSourceGradientColor(RGBA(0, 0, 0, 250), 0.95)
    AddPathCircle(GadgetWidth(gid)/2,GadgetHeight(gid)/2,GadgetWidth(gid)/2.5)
    StrokePath(GadgetWidth(gid)/15,#PB_Path_RoundEnd )
    
    EndVectorLayer()
    
    BeginVectorLayer(180)
    
    VectorSourceColor(RGBA(0,0,0,255))
    loop_step.f = 0
    start_angle = -160
    end_angle = 160
    big_step.f = 48
    x.f = 0
    y.f = 0 
    min.f = 956
    max.f = 1070
    angle.f = 0
    start_draw.f = start_angle
    
    VectorFont(FontID(0), GadgetHeight(gid)/25)
    
    While start_draw <= end_angle
      ResetCoordinates()
      MovePathCursor(GadgetWidth(gid)/2, GadgetWidth(gid)/2)
      RotateCoordinates(GadgetWidth(gid)/2, GadgetHeight(gid)/2, start_draw)
      If Mod(start_draw, big_step) = 0
        MovePathCursor(GadgetWidth(gid)/2, GadgetWidth(gid)/4.5)
        AddPathLine(GadgetWidth(gid)/2, GadgetWidth(gid)/6)
        StrokePath(GadgetWidth(gid)/100,#PB_Path_RoundEnd)
        outval = ((loop_step/(end_angle - start_angle)) * (max - min)) + min
        out$ =  Str(outval)
        x = GadgetWidth(gid)/2 - VectorTextWidth(out$)/2
        y = GadgetWidth(gid)/4.4
        MovePathCursor(x, y)
        DrawVectorText(out$)
      ElseIf Mod(start_draw, 4) = 0
        MovePathCursor(GadgetWidth(gid)/2, GadgetWidth(gid)/5)
        AddPathLine(GadgetWidth(gid)/2, GadgetWidth(gid)/6)
        StrokePath(GadgetWidth(gid)/400,#PB_Path_RoundEnd)
      EndIf
      
      loop_step = loop_step + 1
      start_draw = start_draw + 1
      
    Wend
    
    ResetCoordinates()
    VectorFont(FontID(0), GadgetHeight(gid)/12)
    out$ = StrF(pressvalue,1) + "hPa"
    MovePathCursor(GadgetWidth(gid)/2 - VectorTextWidth(out$)/2, GadgetWidth(gid)/1.8)
    DrawVectorText(out$)
    
    EndVectorLayer()
    
    BeginVectorLayer(250)
    
    ; Pointer
    If colpointer = 0 : colpointer = RGBA(0,0,0,255) : EndIf
    VectorSourceColor(colpointer)
    ResetCoordinates()
    angle = pressvalue - min
    angle = (angle / (max-min)) * (Abs(start_angle) + end_angle)
    RotateCoordinates(GadgetWidth(gid)/2, GadgetHeight(gid)/2,angle + start_angle)
    MovePathCursor(GadgetWidth(gid)/2 + GadgetWidth(gid)/80, GadgetHeight(gid)/2)
    AddPathLine(GadgetWidth(gid)/2, GadgetHeight(gid)/6)
    AddPathLine(GadgetWidth(gid)/2 - GadgetWidth(gid)/80, GadgetHeight(gid)/2)
    FillPath()
    AddPathCircle(GadgetWidth(gid)/2, GadgetHeight(gid)/2, GadgetWidth(gid)/80)
    FillPath()
    
    EndVectorLayer()
    
    StopVectorDrawing()
  EndIf
  
EndProcedure

Procedure resize()
  ; default setting
  ResizeGadget(10, 0, 0, WindowHeight(0)/2, WindowHeight(0)/2)
  ResizeGadget(11, WindowHeight(0)/2, 0, WindowHeight(0)/2, WindowHeight(0)/2)
  ResizeGadget(12, WindowHeight(0), 0, WindowHeight(0)/2, WindowHeight(0)/2)
  ResizeGadget(13, WindowHeight(0)*1.5, 0, WindowHeight(0)/2, WindowHeight(0)/2)
  Draw_3D_Clock(10)
  Draw_3D_Thermometer(11, (Random(800,0)-300)/10)
  Draw_3D_Hygrometer(12, (Random(1000,0))/10)
  Draw_3D_Barometer(13, (Random(10700,9560))/10)
  
  ; custom sizes
  ResizeGadget(14, 0, WindowHeight(0)/2, 0.2 * WindowHeight(0), 0.2*WindowHeight(0))
  ResizeGadget(15, 0.2 *WindowHeight(0), WindowHeight(0)/2, 0.3*WindowHeight(0), 0.3*WindowHeight(0))
  ResizeGadget(16, 0.5* WindowHeight(0), WindowHeight(0)/2, 0.35*WindowHeight(0), 0.35*WindowHeight(0))
  ResizeGadget(17, 0.85* WindowHeight(0), WindowHeight(0)/2, 0.4*WindowHeight(0), 0.4*WindowHeight(0))
  ResizeGadget(18, 1.25* WindowHeight(0), WindowHeight(0)/2, 0.5*WindowHeight(0), 0.5*WindowHeight(0))
  
  ; own colors
  Draw_3D_Clock(14, RGBA(0,125,125,255),RGBA(0,125,125,50))
  Draw_3D_Thermometer(15, (Random(800,0)-300)/10, RGBA(0,125,25,255),RGBA(200,200,220,50))
  Draw_3D_Hygrometer(16, Random(1000,0)/10, RGBA(204, 102, 255,255),RGBA(200,200,220,80))
  Draw_3D_Barometer(17, (Random(10700,9560))/10, RGBA(255, 204, 102,255),RGBA(153, 221, 255, 100), RGBA(204, 51, 0,255))
  Draw_3D_Thermometer(18, (Random(800,0)-300)/10, RGBA(255, 64, 0,120),RGBA(194, 240, 194,100),RGBA(35, 144, 35,255))
EndProcedure

BindEvent(#PB_Event_SizeWindow, @resize(),0)
BindEvent(#PB_Event_Timer, @resize(),0)

If OpenWindow(0, 0, 0, 600, 300, "Simple 3D Weather Gauges", #PB_Window_SystemMenu | #PB_Window_ScreenCentered| #PB_Window_MaximizeGadget | #PB_Window_SizeGadget)
  AddWindowTimer(0, 123,1000)
  LoadFont(0, "Ubuntu", 10,  #PB_Font_HighQuality)
  
  CanvasGadget(10, 0, 0, WindowHeight(0)/2, WindowHeight(0)/2)
  CanvasGadget(11, WindowHeight(0)/2, 0, WindowHeight(0)/2, WindowHeight(0)/2)
  CanvasGadget(12, WindowHeight(0), 0, WindowHeight(0)/2, WindowHeight(0)/2)
  CanvasGadget(13, WindowHeight(0)*1.5, 0, WindowHeight(0)/2, WindowHeight(0)/2)
  ; custom sizes
  CanvasGadget(14, 0, WindowHeight(0)/2, 0.2 * WindowHeight(0), 0.2*WindowHeight(0))
  CanvasGadget(15, 0.2 *WindowHeight(0), WindowHeight(0)/2, 0.3*WindowHeight(0), 0.3*WindowHeight(0))
  CanvasGadget(16, 0.5* WindowHeight(0), WindowHeight(0)/2, 0.35*WindowHeight(0), 0.35*WindowHeight(0))
  CanvasGadget(17, 0.85* WindowHeight(0), WindowHeight(0)/2, 0.4*WindowHeight(0), 0.4*WindowHeight(0))
  CanvasGadget(18, 1.25* WindowHeight(0), WindowHeight(0)/2, 0.5*WindowHeight(0), 0.5*WindowHeight(0))
  
  resize()
  Repeat

    Event = WaitWindowEvent()
    
  Until Event = #PB_Event_CloseWindow
EndIf
; IDE Options = PureBasic 5.71 LTS (Windows - x64)
; CursorPosition = 84
; FirstLine = 75
; Folding = h
; EnableXP